package observation;

import java.rmi.*;

/**
 * This class give some useful methods and the informations used by
 * the observations service.
 */
public class Info
{
    private static final String coordMachine = "rhodes.enseeiht.fr";
    private static final String logMachine = "rhodes.enseeiht.fr";

    /** The RMI service name of the coordinator service. */
    static final String coordName = "Observation";

    /** The RMI service name of the log service. */
    static final String logName = "Log";

    /**
     * The log file (used by the log service only). This field may be
     * moved into the Log class.
     */
    static final String logFileName = "observation.log";

    /** The source table and the image table names of the coordinator. */
    public static final String srcName = "Sources";
    public static final String imgName = "Images";

    public static CoordI lookupCoord() throws Exception{
        CoordI coord;
        System.out.print("Looking up Coord object...");
        coord = (CoordI)Naming.lookup
                    ("rmi://" + Info.coordMachine + "/" + Info.coordName);
        System.out.println("done");
        return coord;
    }

    public static LogI lookupLog() throws Exception{
        LogI log;
        System.out.print("Looking up Log object...");
        log = (LogI)Naming.lookup
                    ("rmi://" + Info.logMachine + "/" + Info.logName);
        System.out.println("done");
        return log;
    }

    public static void setRMISecurityManager() throws ObsException{
        SecurityManager sm;
        sm = System.getSecurityManager();
        if (sm == null)
            System.setSecurityManager(new RMISecurityManager());
        else if (!(sm instanceof RMISecurityManager))
            throw new ObsException(ObsException.securityMan);
    }
}

