package observation;

import java.rmi.*;
import java.rmi.server.*;
import java.io.*;
import java.net.*;

/**
 * This class is the log service. Only one log object is used. It is the
 * one started from the machine indicated by the string Info#logMachine.
 */
public class Log extends UnicastRemoteObject implements LogI
{
    private static PrintWriter log;

    public Log() throws RemoteException{
//        java.rmi.registry.LocateRegistry.createRegistry(1099);
        System.out.print("Opening log file...");
        try{
            log = new PrintWriter(new FileWriter( Info.logFileName,
                       true), true);    // append
        }catch(IOException e){
            e.printStackTrace();
        }
        log.println("\nNouveau lancement");
        System.out.println("done");
    }

    /**
     * Writes an entry into the journal.
     * @param s the string to be written.
     */
    public void writeEntry(String s) throws RemoteException{
        log.println(s);
    }

    // cree un objet distant log
    public static void main(String args[]){
        try{
            Info.setRMISecurityManager();
            Log l = new Log();
            Naming.bind("rmi://" + InetAddress.getLocalHost().getHostName() +
                        "/" + Info.logName, l);
            System.out.println("Service log binded");
        } catch(Exception e){
            e.printStackTrace();
        }
    }
}

