import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.net.*;
import observation.*;

class UpdateThread extends Thread
{
    private ObsReader obs;
    UpdateThread(ObsReader o){
        obs = o;
    }
    public void run(){
        while (true){
            obs.fillSrcList();
            obs.fillImgList();
            try{
                Thread.sleep(1000);
            }catch(Exception e){
                e.printStackTrace();
            }
        }
    }
}

public class ObsReader extends Applet
{
    List srcList, imgList;
    observation.Image imgSrcTable, imgImgTable;

    public void init(){
        Label srcLabel = new Label("Sources");
        srcList = new List(10, false);
        Panel srcPanel = new Panel();
        srcPanel.add(srcLabel);
        srcPanel.add(srcList);
        add(srcPanel);

        Label imgLabel = new Label("Images");
        imgList = new List(10, false);
        Panel imgPanel = new Panel();
        imgPanel.add(imgLabel);
        imgPanel.add(imgList);
        add(imgPanel);

        createImages();
    }

    void createImages(){
        try{
            imgSrcTable = new observation.Image(
                              "ObsReader.src." +
                              InetAddress.getLocalHost().getHostName(),
                              Info.srcName, 0, 10000);
            imgImgTable = new observation.Image(
                              "ObsReader.img." +
                              InetAddress.getLocalHost().getHostName(),
                              Info.imgName, 0, 10000);
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    void fillSrcList(){
        srcList.removeAll();
        Enumeration e = ((Hashtable)imgSrcTable.var).keys();
        while(e.hasMoreElements())
            srcList.add((String)e.nextElement());
    }

    void fillImgList(){
        Hashtable h = (Hashtable)imgImgTable.var;
        imgList.removeAll();
        Enumeration e = h.keys();
        while(e.hasMoreElements()){
            Object elem = e.nextElement();
            imgList.add((String)elem + " - " +
                        ((ImgItem)h.get(elem)).srcName);
        }
    }

    public void start(){
        (new UpdateThread(this)).start();
    }

    public class WL extends WindowAdapter
    {
        public void windowClosing(WindowEvent e){
            try{
                imgSrcTable.remove();
                imgImgTable.remove();
            }catch(RemoteException ee){
                ee.printStackTrace();
            }
            System.exit(0);
        }
    }

    // s'il fait des connections exterieures, il ne peut pas etre lance comme applet
    public static void main(String args[]){
        ObsReader applet = new ObsReader();
        Frame aFrame = new Frame("ObsReader");
        aFrame.addWindowListener(applet.new WL());
        aFrame.add(applet, BorderLayout.CENTER);
        aFrame.setSize(600, 200);
        applet.init();
        applet.start();
        aFrame.setVisible(true);
    }
}

